package simpleex.restserver;

import java.io.IOException;
import java.net.URI;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.glassfish.grizzly.http.server.HttpServer;
import org.glassfish.jersey.grizzly2.httpserver.GrizzlyHttpServerFactory;
import org.glassfish.jersey.server.ResourceConfig;

public class LatLongGrizzlyApp {

  private static URI BASE_URI = URI.create("http://localhost:8080/");

  public static HttpServer startServer(final String[] args) throws IOException {
    final URI baseUri = (args.length >= 1 ? URI.create(args[0]) : BASE_URI);
    final ResourceConfig resourceConfig = (args.length >= 2 ? new LatLongConfig(args[1]) : new LatLongConfig());
    return GrizzlyHttpServerFactory.createHttpServer(baseUri, resourceConfig);
  }

  public static void stopServer(final HttpServer server) throws IOException {
    server.shutdown();
  }

  public static void main(final String[] args) throws IOException {
    try {
      final HttpServer server = startServer(args);
      Runtime.getRuntime().addShutdownHook(new Thread(server::shutdownNow));
      Thread.currentThread().join();
    } catch (final InterruptedException ex) {
      Logger.getLogger(LatLongGrizzlyApp.class.getName()).log(Level.SEVERE, null, ex);
    }
  }
}
